import { csv, select, scaleLinear } from 'd3';
//
import { scatterPlot } from './scatterPlot';
import { menu } from './menu';
const csvUrl = [
  'https://gist.githubusercontent.com/',
  'curran/',
  'a08a1080b88344b0c8a7/',
  'raw/0e7a9b0a5d22642a06d3d5b9bcbad9890c8ee534/',
  'iris.csv',
].join('');
// console.log(d3);
//csv(csvUrl) is a request operation
//columns ['sepal.length', 'sepal.width', 'petal.length', 'petal.width', 'variety']
const parseRow = (d) => {
  d.sepal_length = +d.sepal_length;
  d.sepal_width = +d.sepal_width;
  d.petal_length = +d.petal_length;
  d.petal_width = +d.petal_width;
  console.log(typeof d.sepal_length);

  return d;
};

//       const xValue = (d) => {
//         d.sepal_length = +d.sepal_length;
//         d.sepal_width = +d.sepal_width;
//         d.petal_length = +d.petal_length;

//         d.petal_width = +d.petal_width;

//         return d.petal_length;
//       };
//       const yValue = (d) => {
//         d.sepal_length = +d.sepal_length;
//         d.sepal_width = +d.sepal_width;
//         d.petal_length = +d.petal_length;
//         d.petal_width = +d.petal_width;
//         return d.sepal_length;
//       };

const width = window.innerWidth;
const height = window.innerHeight;

const svg = select('body')
  .append('svg')
  .attr('width', width)
  .attr('height', height);

const menuContainer = select('body')
  .append('div')
  .attr('class', 'menu-container');
const xMenu = menuContainer.append('div');
const yMenu = menuContainer.append('div');

const main = async () => {
  const data = await csv(csvUrl, parseRow);
  const plot = scatterPlot()
    .width(width)
    .height(height)
    .data(data)
    .xValue((d) => d.petal_width)
    .yValue((d) => d.petal_width)
    .margin({
      top: 20,
      right: 20,
      left: 50,
      bottom: 40,
    })
    .radius(5);
  svg.call(plot);

  const options = [
    {
      value: 'petal_width',
      text: 'Petal Width',
      type: 'quantitative',
    },
    {
      value: 'sepal_width',
      text: 'Sepal Width',
      type: 'quantitative',
    },
    {
      value: 'petal_length',
      text: 'Petal Length',
      type: 'quantitative',
    },
    {
      value: 'sepal_length',
      text: 'Sepal Length',
      type: 'quantitative',
    },
    {
      value: 'species',
      text: 'Species',
      type: 'categorical',
    },
  ];

  // menuContainer.call(menu());
  xMenu.call(
    menu()
      .id('x-menu')
      .labelText('X:  ')
      .options(options)
      .on('change', (column) => {
        // console.log('in index.js');
        // console.log(value);
        svg.call(plot.xValue((d) => d[column]));
      })
  );
  yMenu.call(
    menu()
      .id('y-menu')
      .labelText('Y:  ')
      .options(options)
      .on('change', (column) => {
        // console.log('in index.js');
        // console.log(value);
        svg.call(plot.yValue((d) => d[column]));
      })
  );
  //   let i = 0;
  //   setInterval(() => {

  //     plot.xValue((d) => d[columns[i % columns.length]]);
  //     svg.call(plot);
  //     i++;
  //   }, 6000);
};
main();
